package com.example.user.myapp;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;

import com.ghgande.j2mod.modbus.ModbusException;
import com.ghgande.j2mod.modbus.facade.ModbusTCPMaster;
import com.ghgande.j2mod.modbus.io.ModbusTCPTransaction;
import com.ghgande.j2mod.modbus.io.ModbusTransaction;
import com.ghgande.j2mod.modbus.msg.ModbusResponse;
import com.ghgande.j2mod.modbus.msg.ReadCoilsRequest;
import com.ghgande.j2mod.modbus.msg.ReadCoilsResponse;
import com.ghgande.j2mod.modbus.net.TCPMasterConnection;
import com.ghgande.j2mod.modbus.util.BitVector;

import java.net.InetAddress;

public class MyTest extends AsyncTask<String, Void, String> {

  //  private ModbusTCPMaster master = null;
    TCPMasterConnection connection = null;
    Activity prevActivityContext = null;

    public MyTest (Activity context, TCPMasterConnection connection) {
        this.connection = connection;
        this.prevActivityContext = context;
    }

    @Override
    protected String doInBackground(String...strings) {
        System.out.println("Pass !! ");
        boolean open = false;
        try {
          //  master = new ModbusTCPMaster(strings[0], 503);

         //   InetAddress inetAddress = InetAddress.getByName("192.168.157.16");
        //    TCPMasterConnection connection = new TCPMasterConnection(inetAddress);
        //    connection.setPort(503);
            connection.connect();
            open = connection.isConnected();
//
            System.out.print("am i open : "+open);



            ReadCoilsRequest request = new ReadCoilsRequest(8192, 8);

            ModbusTransaction transaction = new ModbusTCPTransaction(connection);
            transaction.setRequest(request);
            transaction.execute();

            BitVector bv = ((ReadCoilsResponse) getAndCheckResponse(transaction)).getCoils();
              // bv.forceSize(count);
            System.out.println("my bit  :"+bv.getBit(0));
            connection.close();

          //  this.master.connect();
       //     master.connect();
       //     return null;
            return "i'm connected";
        } catch (Exception e) {
            return e.getMessage();
        }
    }

    protected void onPostExecute(String string) {
        //     //   try {
            System.out.println("finished");
            System.out.println(string);

            Intent intent = new Intent(this.prevActivityContext, DisplayMessageActivity.class);
       //     intent.putExtra("connection", (Object) this.master);
         //   System.out.println (master);

            prevActivityContext.startActivity(intent);

    }


    private ModbusResponse getAndCheckResponse(ModbusTransaction transaction) throws ModbusException {
        ModbusResponse res = transaction.getResponse();
        if (res == null) {
            throw new ModbusException("No response");
        }
        return res;
    }
}
